Index: .gitignore
===================================================================
--- .gitignore	(revision eda4323867bf5a8e98aa598c3cca1e3fb59f4e7a)
+++ .gitignore	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -4,4 +4,5 @@
 /doxygen/latex
 /tools/*.pyc
+/tools/__pycache__
 tags
 tools/sycek/
Index: abi/include/abi/ipc/interfaces.h
===================================================================
--- abi/include/abi/ipc/interfaces.h	(revision eda4323867bf5a8e98aa598c3cca1e3fb59f4e7a)
+++ abi/include/abi/ipc/interfaces.h	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -1,3 +1,4 @@
 /*
+ * Copyright (c) 2023 Jiri Svoboda
  * Copyright (c) 2014 Martin Decky
  * All rights reserved.
@@ -186,4 +187,8 @@
 	INTERFACE_DDEV =
 	    FOURCC_COMPACT('d', 'd', 'e', 'v') | IFACE_EXCHANGE_SERIALIZE,
+	INTERFACE_DISPCFG =
+	    FOURCC_COMPACT('d', 'c', 'f', 'g') | IFACE_EXCHANGE_SERIALIZE,
+	INTERFACE_DISPCFG_CB =
+	    FOURCC_COMPACT('d', 'c', 'f', 'g') | IFACE_EXCHANGE_SERIALIZE | IFACE_MOD_CALLBACK,
 	INTERFACE_DISPLAY =
 	    FOURCC_COMPACT('d', 's', 'p', 'l') | IFACE_EXCHANGE_SERIALIZE,
@@ -192,4 +197,8 @@
 	INTERFACE_GC =
 	    FOURCC_COMPACT('g', 'f', 'x', 'c') | IFACE_EXCHANGE_SERIALIZE,
+	INTERFACE_WNDMGT =
+	    FOURCC_COMPACT('w', 'm', 'g', 't') | IFACE_EXCHANGE_SERIALIZE,
+	INTERFACE_WNDMGT_CB =
+	    FOURCC_COMPACT('w', 'm', 'g', 't') | IFACE_EXCHANGE_SERIALIZE | IFACE_MOD_CALLBACK,
 } iface_t;
 
Index: uspace/app/barber/barber.c
===================================================================
--- uspace/app/barber/barber.c	(revision eda4323867bf5a8e98aa598c3cca1e3fb59f4e7a)
+++ uspace/app/barber/barber.c	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -361,5 +361,5 @@
 
 	ui_wnd_params_init(&params);
-	params.caption = "";
+	params.caption = "Barber Pole";
 	params.placement = ui_wnd_place_bottom_right;
 	/*
Index: uspace/app/gfxdemo/gfxdemo.c
===================================================================
--- uspace/app/gfxdemo/gfxdemo.c	(revision eda4323867bf5a8e98aa598c3cca1e3fb59f4e7a)
+++ uspace/app/gfxdemo/gfxdemo.c	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -244,5 +244,5 @@
 
 		pos.x = w / 2;
-		pos.y = h - 1;
+		pos.y = h;
 		rc = gfx_puttext(&pos, &fmt, text);
 		if (rc != EOK) {
@@ -801,4 +801,85 @@
 }
 
+/** Run text abbreviation demo on a graphic context.
+ *
+ * @param gc Graphic context
+ * @param w Width
+ * @param h Height
+ */
+static errno_t demo_text_abbr(gfx_context_t *gc, gfx_coord_t w, gfx_coord_t h)
+{
+	gfx_color_t *color = NULL;
+	gfx_rect_t rect;
+	gfx_coord2_t pos;
+	gfx_text_fmt_t fmt;
+	int i;
+	errno_t rc;
+
+	if (quit)
+		return EOK;
+
+	rc = demo_begin(gc, w, h, "Text abbreviation");
+	if (rc != EOK)
+		goto error;
+
+	for (i = 0; i < 11; i++) {
+
+		rc = gfx_color_new_rgb_i16(0, 0, 0x8000, &color);
+		if (rc != EOK)
+			goto error;
+
+		rc = gfx_set_color(gc, color);
+		if (rc != EOK)
+			goto error;
+
+		rect.p0.x = w / 20;
+		rect.p0.y = (2 + 2 * i) * h / 25;
+		rect.p1.x = w - w / 20 - w * i / 12;
+		rect.p1.y = (3 + 2 * i) * h / 25;
+
+		rc = gfx_fill_rect(gc, &rect);
+		if (rc != EOK)
+			goto error;
+
+		gfx_color_delete(color);
+
+		if (demo_is_text(w, h)) {
+			rc = gfx_color_new_ega(0x1f, &color);
+			if (rc != EOK)
+				goto error;
+		} else {
+			rc = gfx_color_new_rgb_i16(0xffff, 0xffff, 0xffff,
+			    &color);
+			if (rc != EOK)
+				goto error;
+		}
+
+		gfx_text_fmt_init(&fmt);
+		fmt.font = font;
+		fmt.color = color;
+		fmt.abbreviate = true;
+		fmt.width = rect.p1.x - rect.p0.x;
+
+		pos.x = rect.p0.x;
+		pos.y = rect.p0.y;
+		rc = gfx_puttext(&pos, &fmt,
+		    "The quick brow fox jumps over the lazy dog!");
+		if (rc != EOK) {
+			printf("Error rendering text.\n");
+			goto error;
+		}
+	}
+
+	for (i = 0; i < 10; i++) {
+		fibril_usleep(500 * 1000);
+		if (quit)
+			break;
+	}
+
+	return EOK;
+error:
+	return rc;
+}
+
 /** Run clipping demo on a graphic context.
  *
@@ -933,4 +1014,8 @@
 
 		rc = demo_text(gc, w, h);
+		if (rc != EOK)
+			goto error;
+
+		rc = demo_text_abbr(gc, w, h);
 		if (rc != EOK)
 			goto error;
@@ -1069,4 +1154,5 @@
 	params.rect.p1.x = 400;
 	params.rect.p1.y = 300;
+	params.caption = "GFX Demo";
 
 	rc = display_window_create(display, &params, &wnd_cb, NULL, &window);
Index: uspace/app/init/init.c
===================================================================
--- uspace/app/init/init.c	(revision eda4323867bf5a8e98aa598c3cca1e3fb59f4e7a)
+++ uspace/app/init/init.c	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -477,5 +477,5 @@
 		if (rc == EOK) {
 			app_start("/app/launcher", NULL);
-			app_start("/app/barber", NULL);
+			app_start("/app/taskbar", NULL);
 			app_start("/app/terminal", "-topleft");
 		}
Index: uspace/app/meson.build
===================================================================
--- uspace/app/meson.build	(revision eda4323867bf5a8e98aa598c3cca1e3fb59f4e7a)
+++ uspace/app/meson.build	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -79,4 +79,5 @@
 	'sysinfo',
 	'sysinst',
+	'taskbar',
 	'taskdump',
 	'terminal',
Index: uspace/app/taskbar/clock.c
===================================================================
--- uspace/app/taskbar/clock.c	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
+++ uspace/app/taskbar/clock.c	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -0,0 +1,341 @@
+/*
+ * Copyright (c) 2022 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup taskbar
+ * @{
+ */
+/** @file Task bar clock.
+ *
+ * Displays the current time in an inset frame.
+ */
+
+#include <errno.h>
+#include <gfx/render.h>
+#include <gfx/text.h>
+#include <stdlib.h>
+#include <stdio.h>
+#include <task.h>
+#include <ui/control.h>
+#include <ui/paint.h>
+#include <ui/resource.h>
+#include <ui/ui.h>
+#include "clock.h"
+
+static void taskbar_clock_ctl_destroy(void *);
+static errno_t taskbar_clock_ctl_paint(void *);
+static ui_evclaim_t taskbar_clock_ctl_kbd_event(void *, kbd_event_t *);
+static ui_evclaim_t taskbar_clock_ctl_pos_event(void *, pos_event_t *);
+static void taskbar_clock_timer(void *);
+
+/** Task bar clock control ops */
+static ui_control_ops_t taskbar_clock_ctl_ops = {
+	.destroy = taskbar_clock_ctl_destroy,
+	.paint = taskbar_clock_ctl_paint,
+	.kbd_event = taskbar_clock_ctl_kbd_event,
+	.pos_event = taskbar_clock_ctl_pos_event
+};
+
+/** Create task bar clock.
+ *
+ * @param window Containing window
+ * @param rclock Place to store pointer to new clock
+ * @return EOK on success or an error code
+ */
+errno_t taskbar_clock_create(ui_window_t *window, taskbar_clock_t **rclock)
+{
+	taskbar_clock_t *clock;
+	errno_t rc;
+
+	clock = calloc(1, sizeof(taskbar_clock_t));
+	if (clock == NULL)
+		return ENOMEM;
+
+	rc = ui_control_new(&taskbar_clock_ctl_ops, (void *)clock,
+	    &clock->control);
+	if (rc != EOK) {
+		free(clock);
+		return rc;
+	}
+
+	clock->timer = fibril_timer_create(NULL);
+	if (clock->timer == NULL) {
+		rc = ENOMEM;
+		goto error;
+	}
+
+	fibril_mutex_initialize(&clock->lock);
+	fibril_condvar_initialize(&clock->timer_done_cv);
+	fibril_timer_set(clock->timer, 1000000, taskbar_clock_timer, clock);
+
+	clock->window = window;
+	*rclock = clock;
+	return EOK;
+error:
+	ui_control_delete(clock->control);
+	free(clock);
+	return rc;
+}
+
+/** Destroy task bar clock.
+ *
+ * @param clock Task bar clock
+ */
+void taskbar_clock_destroy(taskbar_clock_t *clock)
+{
+	/*
+	 * Signal to the timer that we are cleaning up. If the timer handler
+	 * misses it and sets the timer again, we will clear that active
+	 * timer and be done (and if we were even slower and the timer
+	 * fired again, it's the same situation as before.
+	 */
+	fibril_mutex_lock(&clock->lock);
+	clock->timer_cleanup = true;
+	fibril_mutex_unlock(&clock->lock);
+
+	/* If we catch the timer while it's active, there's nothing to do. */
+	if (fibril_timer_clear(clock->timer) != fts_active) {
+		/* Need to wait for timer handler to finish */
+		fibril_mutex_lock(&clock->lock);
+		while (clock->timer_done == false)
+			fibril_condvar_wait(&clock->timer_done_cv, &clock->lock);
+		fibril_mutex_unlock(&clock->lock);
+	}
+
+	fibril_timer_destroy(clock->timer);
+	ui_control_delete(clock->control);
+	free(clock);
+}
+
+static errno_t taskbar_clock_get_text(taskbar_clock_t *clock, char *buf,
+    size_t bsize)
+{
+	struct timespec ts;
+	struct tm tm;
+	errno_t rc;
+
+	getrealtime(&ts);
+	rc = time_utc2tm(ts.tv_sec, &tm);
+	if (rc != EOK)
+		return rc;
+
+	snprintf(buf, bsize, "%02d:%02d:%02d", tm.tm_hour, tm.tm_min,
+	    tm.tm_sec);
+	return EOK;
+}
+
+/** Paint task bar clock.
+ *
+ * @param clock Task bar clock
+ */
+errno_t taskbar_clock_paint(taskbar_clock_t *clock)
+{
+	gfx_context_t *gc = ui_window_get_gc(clock->window);
+	ui_resource_t *res = ui_window_get_res(clock->window);
+	ui_t *ui = ui_window_get_ui(clock->window);
+	char buf[10];
+	gfx_text_fmt_t fmt;
+	gfx_coord2_t pos;
+	gfx_rect_t irect;
+	errno_t rc;
+
+	if (!ui_is_textmode(ui)) {
+		/* Paint frame */
+		rc = ui_paint_inset_frame(res, &clock->rect, &irect);
+		if (rc != EOK)
+			goto error;
+	} else {
+		irect = clock->rect;
+	}
+
+	rc = gfx_set_color(gc, ui_resource_get_wnd_face_color(res));
+	if (rc != EOK)
+		goto error;
+
+	/* Fill background */
+	rc = gfx_fill_rect(gc, &irect);
+	if (rc != EOK)
+		goto error;
+
+	pos.x = (irect.p0.x + irect.p1.x) / 2;
+	pos.y = (irect.p0.y + irect.p1.y) / 2;
+
+	gfx_text_fmt_init(&fmt);
+	fmt.font = ui_resource_get_font(res);
+	fmt.color = ui_resource_get_wnd_text_color(res);
+	fmt.halign = gfx_halign_center;
+	fmt.valign = gfx_valign_center;
+
+	rc = taskbar_clock_get_text(clock, buf, sizeof(buf));
+	if (rc != EOK)
+		goto error;
+
+	rc = gfx_puttext(&pos, &fmt, buf);
+	if (rc != EOK)
+		goto error;
+
+	rc = gfx_update(gc);
+	if (rc != EOK)
+		goto error;
+
+	return EOK;
+error:
+	return rc;
+}
+
+/** Handle task bar clock keyboard event.
+ *
+ * @param clock Task bar clock
+ * @param event Keyboard event
+ * @return ui_claimed iff event was claimed
+ */
+ui_evclaim_t taskbar_clock_kbd_event(taskbar_clock_t *clock, kbd_event_t *event)
+{
+	return ui_unclaimed;
+}
+
+/** Handle task bar clock position event.
+ *
+ * @param clock Task bar clock
+ * @param event Position event
+ * @return ui_claimed iff event was claimed
+ */
+ui_evclaim_t taskbar_clock_pos_event(taskbar_clock_t *clock, pos_event_t *event)
+{
+	gfx_coord2_t pos;
+
+	pos.x = event->hpos;
+	pos.y = event->vpos;
+	if (!gfx_pix_inside_rect(&pos, &clock->rect))
+		return ui_unclaimed;
+
+	return ui_claimed;
+}
+
+/** Get base control for task bar clock.
+ *
+ * @param clock Task bar clock
+ * @return Base UI control
+ */
+ui_control_t *taskbar_clock_ctl(taskbar_clock_t *clock)
+{
+	return clock->control;
+}
+
+/** Set task bar clock rectangle.
+ *
+ * @param clock Task bar clock
+ * @param rect Rectangle
+ */
+void taskbar_clock_set_rect(taskbar_clock_t *clock, gfx_rect_t *rect)
+{
+	gfx_rect_t irect;
+
+	clock->rect = *rect;
+
+	irect.p0.x = clock->rect.p0.x + 1;
+	irect.p0.y = clock->rect.p0.y + 1;
+	irect.p1.x = clock->rect.p1.x;
+	irect.p1.y = clock->rect.p1.y - 1;
+
+	(void)irect;
+}
+
+/** Destroy clock control.
+ *
+ * @param arg Argument (taskbar_clock_t *)
+ */
+void taskbar_clock_ctl_destroy(void *arg)
+{
+	taskbar_clock_t *clock = (taskbar_clock_t *) arg;
+
+	taskbar_clock_destroy(clock);
+}
+
+/** Paint task bar clock control.
+ *
+ * @param arg Argument (taskbar_clock_t *)
+ * @return EOK on success or an error code
+ */
+errno_t taskbar_clock_ctl_paint(void *arg)
+{
+	taskbar_clock_t *clock = (taskbar_clock_t *) arg;
+
+	return taskbar_clock_paint(clock);
+}
+
+/** Handle task bar clock control keyboard event.
+ *
+ * @param arg Argument (taskbar_clock_t *)
+ * @param kbd_event Keyboard event
+ * @return @c ui_claimed iff the event is claimed
+ */
+ui_evclaim_t taskbar_clock_ctl_kbd_event(void *arg, kbd_event_t *event)
+{
+	taskbar_clock_t *clock = (taskbar_clock_t *) arg;
+
+	return taskbar_clock_kbd_event(clock, event);
+}
+
+/** Handle task bar clock control position event.
+ *
+ * @param arg Argument (taskbar_clock_t *)
+ * @param pos_event Position event
+ * @return @c ui_claimed iff the event is claimed
+ */
+ui_evclaim_t taskbar_clock_ctl_pos_event(void *arg, pos_event_t *event)
+{
+	taskbar_clock_t *clock = (taskbar_clock_t *) arg;
+
+	return taskbar_clock_pos_event(clock, event);
+}
+
+/** Taskbar clock timer handler.
+ *
+ * @param arg Argument (taskbar_clock_t *)
+ */
+static void taskbar_clock_timer(void *arg)
+{
+	taskbar_clock_t *clock = (taskbar_clock_t *) arg;
+
+	fibril_mutex_lock(&clock->lock);
+	(void) taskbar_clock_paint(clock);
+
+	if (!clock->timer_cleanup) {
+		fibril_timer_set(clock->timer, 1000000, taskbar_clock_timer,
+		    clock);
+	} else {
+		/* Acknowledge timer cleanup */
+		clock->timer_done = true;
+		fibril_condvar_signal(&clock->timer_done_cv);
+	}
+
+	fibril_mutex_unlock(&clock->lock);
+}
+
+/** @}
+ */
Index: uspace/app/taskbar/clock.h
===================================================================
--- uspace/app/taskbar/clock.h	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
+++ uspace/app/taskbar/clock.h	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -0,0 +1,59 @@
+/*
+ * Copyright (c) 2022 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup taskbar
+ * @{
+ */
+/**
+ * @file Task bar clock
+ */
+
+#ifndef CLOCK_H
+#define CLOCK_H
+
+#include <errno.h>
+#include <gfx/coord.h>
+#include <io/kbd_event.h>
+#include <io/pos_event.h>
+#include <ui/control.h>
+#include <ui/window.h>
+#include <stdbool.h>
+#include "types/clock.h"
+
+extern errno_t taskbar_clock_create(ui_window_t *, taskbar_clock_t **);
+extern void taskbar_clock_destroy(taskbar_clock_t *);
+extern errno_t taskbar_clock_paint(taskbar_clock_t *);
+extern ui_evclaim_t taskbar_clock_kbd_event(taskbar_clock_t *, kbd_event_t *);
+extern ui_evclaim_t taskbar_clock_pos_event(taskbar_clock_t *, pos_event_t *);
+extern ui_control_t *taskbar_clock_ctl(taskbar_clock_t *);
+extern void taskbar_clock_set_rect(taskbar_clock_t *, gfx_rect_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/app/taskbar/doc/doxygroups.h
===================================================================
--- uspace/app/taskbar/doc/doxygroups.h	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
+++ uspace/app/taskbar/doc/doxygroups.h	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -0,0 +1,4 @@
+/** @addtogroup taskbar taskbar
+ * @brief Task bar
+ * @ingroup apps
+ */
Index: uspace/app/taskbar/main.c
===================================================================
--- uspace/app/taskbar/main.c	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
+++ uspace/app/taskbar/main.c	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -0,0 +1,96 @@
+/*
+ * Copyright (c) 2022 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup taskbar
+ * @{
+ */
+/** @file Task Bar
+ */
+
+#include <stdio.h>
+#include <str.h>
+#include <ui/ui.h>
+#include "taskbar.h"
+
+static void print_syntax(void)
+{
+	printf("Syntax: taskbar [-d <display-spec>]\n");
+}
+
+int main(int argc, char *argv[])
+{
+	const char *display_spec = UI_ANY_DEFAULT;
+	const char *wndmgt_svc = WNDMGT_DEFAULT;
+	taskbar_t *taskbar;
+	errno_t rc;
+	int i;
+
+	i = 1;
+	while (i < argc && argv[i][0] == '-') {
+		if (str_cmp(argv[i], "-d") == 0) {
+			++i;
+			if (i >= argc) {
+				printf("Argument missing.\n");
+				print_syntax();
+				return 1;
+			}
+
+			display_spec = argv[i++];
+		} else if (str_cmp(argv[i], "-w") == 0) {
+			++i;
+			if (i >= argc) {
+				printf("Argument missing.\n");
+				print_syntax();
+				return 1;
+			}
+
+			wndmgt_svc = argv[i++];
+		} else {
+			printf("Invalid option '%s'.\n", argv[i]);
+			print_syntax();
+			return 1;
+		}
+	}
+
+	if (i < argc) {
+		print_syntax();
+		return 1;
+	}
+
+	rc = taskbar_create(display_spec, wndmgt_svc, &taskbar);
+	if (rc != EOK)
+		return 1;
+
+	ui_run(taskbar->ui);
+	taskbar_destroy(taskbar);
+
+	return 0;
+}
+
+/** @}
+ */
Index: uspace/app/taskbar/meson.build
===================================================================
--- uspace/app/taskbar/meson.build	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
+++ uspace/app/taskbar/meson.build	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -0,0 +1,45 @@
+#
+# Copyright (c) 2022 Jiri Svoboda
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+deps = [ 'ui', 'wndmgt' ]
+src = files(
+	'clock.c',
+	'main.c',
+	'taskbar.c',
+	'wndlist.c',
+)
+
+test_src = files(
+	'clock.c',
+	'taskbar.c',
+	'wndlist.c',
+	'test/clock.c',
+	'test/main.c',
+	'test/taskbar.c',
+	'test/wndlist.c',
+)
Index: uspace/app/taskbar/taskbar.c
===================================================================
--- uspace/app/taskbar/taskbar.c	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
+++ uspace/app/taskbar/taskbar.c	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -0,0 +1,277 @@
+/*
+ * Copyright (c) 2022 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup taskbar
+ * @{
+ */
+/** @file Task Bar
+ */
+
+#include <gfx/coord.h>
+#include <io/pos_event.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <str.h>
+#include <ui/fixed.h>
+#include <ui/label.h>
+#include <ui/resource.h>
+#include <ui/ui.h>
+#include <ui/window.h>
+#include <wndmgt.h>
+#include "clock.h"
+#include "taskbar.h"
+#include "wndlist.h"
+
+static void taskbar_wnd_close(ui_window_t *, void *);
+static void taskbar_wnd_pos(ui_window_t *, void *, pos_event_t *);
+
+static ui_window_cb_t window_cb = {
+	.close = taskbar_wnd_close,
+	.pos = taskbar_wnd_pos
+};
+
+/** Window close button was clicked.
+ *
+ * @param window Window
+ * @param arg Argument (taskbar)
+ */
+static void taskbar_wnd_close(ui_window_t *window, void *arg)
+{
+	taskbar_t *taskbar = (taskbar_t *) arg;
+
+	ui_quit(taskbar->ui);
+}
+
+/** Window received position event.
+ *
+ * @param window Window
+ * @param arg Argument (taskbar)
+ * @param event Position event
+ */
+static void taskbar_wnd_pos(ui_window_t *window, void *arg, pos_event_t *event)
+{
+	taskbar_t *taskbar = (taskbar_t *) arg;
+
+	/* Remember ID of device that sent the last event */
+	taskbar->wndlist->ev_pos_id = event->pos_id;
+
+	ui_window_def_pos(window, event);
+}
+
+/** Create task bar.
+ *
+ * @param display_spec Display specification
+ * @param wndmgt_svc Window management service (or WNDMGT_DEFAULT)
+ * @param rtaskbar Place to store pointer to new task bar
+ * @return @c EOK on success or an error coe
+ */
+errno_t taskbar_create(const char *display_spec, const char *wndmgt_svc,
+    taskbar_t **rtaskbar)
+{
+	ui_wnd_params_t params;
+	taskbar_t *taskbar = NULL;
+	gfx_rect_t scr_rect;
+	gfx_rect_t rect;
+	ui_resource_t *ui_res;
+	errno_t rc;
+
+	taskbar = calloc(1, sizeof(taskbar_t));
+	if (taskbar == NULL) {
+		rc = ENOMEM;
+		goto error;
+	}
+
+	rc = ui_create(display_spec, &taskbar->ui);
+	if (rc != EOK) {
+		printf("Error creating UI on display %s.\n", display_spec);
+		goto error;
+	}
+
+	rc = ui_get_rect(taskbar->ui, &scr_rect);
+	if (rc != EOK) {
+		if (str_cmp(display_spec, UI_DISPLAY_NULL) != 0) {
+			printf("Error getting screen dimensions.\n");
+			goto error;
+		}
+
+		/* For the sake of unit tests */
+		scr_rect.p0.x = 0;
+		scr_rect.p0.y = 0;
+		scr_rect.p1.x = 100;
+		scr_rect.p1.y = 100;
+	}
+
+	ui_wnd_params_init(&params);
+	params.caption = "Task Bar";
+	params.placement = ui_wnd_place_bottom_left;
+
+	/* Window has no titlebar */
+	params.style &= ~ui_wds_titlebar;
+
+	/* Window is not obscured by other windows */
+	params.flags |= ui_wndf_topmost;
+
+	/* Prevent taskbar window from being listed in taskbar */
+	params.flags |= ui_wndf_system;
+
+	/* Make maximized windows avoid taskbar */
+	params.flags |= ui_wndf_avoid;
+
+	params.rect.p0.x = 0;
+	params.rect.p0.y = 0;
+	params.rect.p1.x = scr_rect.p1.x - scr_rect.p0.x;
+
+	if (ui_is_textmode(taskbar->ui)) {
+		params.rect.p1.y = 1;
+		params.style &= ~ui_wds_frame;
+	} else {
+		params.rect.p1.y = 32;
+	}
+
+	rc = ui_window_create(taskbar->ui, &params, &taskbar->window);
+	if (rc != EOK) {
+		printf("Error creating window.\n");
+		goto error;
+	}
+
+	ui_window_set_cb(taskbar->window, &window_cb, (void *)taskbar);
+	ui_res = ui_window_get_res(taskbar->window);
+
+	rc = ui_fixed_create(&taskbar->fixed);
+	if (rc != EOK) {
+		printf("Error creating fixed layout.\n");
+		goto error;
+	}
+
+	rc = ui_label_create(ui_res, "HelenOS", &taskbar->label);
+	if (rc != EOK) {
+		printf("Error creating label.\n");
+		goto error;
+	}
+
+	ui_window_get_app_rect(taskbar->window, &rect);
+	if (ui_is_textmode(taskbar->ui)) {
+		rect.p0.x += 1;
+	} else {
+		rect.p0.x += 10;
+	}
+	ui_label_set_rect(taskbar->label, &rect);
+	ui_label_set_halign(taskbar->label, gfx_halign_left);
+	ui_label_set_valign(taskbar->label, gfx_valign_center);
+
+	rc = ui_fixed_add(taskbar->fixed, ui_label_ctl(taskbar->label));
+	if (rc != EOK) {
+		printf("Error adding control to layout.\n");
+		ui_label_destroy(taskbar->label);
+		goto error;
+	}
+
+	rc = wndlist_create(taskbar->window, taskbar->fixed, &taskbar->wndlist);
+	if (rc != EOK) {
+		printf("Error creating window list.\n");
+		goto error;
+	}
+
+	if (ui_is_textmode(taskbar->ui)) {
+		rect.p0.x = params.rect.p0.x + 9;
+		rect.p0.y = 0;
+		rect.p1.x = params.rect.p1.x - 10;
+		rect.p1.y = 1;
+	} else {
+		rect.p0.x = params.rect.p0.x + 90;
+		rect.p0.y = 4;
+		rect.p1.x = params.rect.p1.x - 84;
+		rect.p1.y = 32 - 4;
+	}
+	wndlist_set_rect(taskbar->wndlist, &rect);
+
+	rc = wndlist_open_wm(taskbar->wndlist, wndmgt_svc);
+	if (rc != EOK) {
+		printf("Error attaching window management service.\n");
+		goto error;
+	}
+
+	rc = taskbar_clock_create(taskbar->window, &taskbar->clock);
+	if (rc != EOK)
+		goto error;
+
+	if (ui_is_textmode(taskbar->ui)) {
+		rect.p0.x = params.rect.p1.x - 10;
+		rect.p0.y = 0;
+		rect.p1.x = params.rect.p1.x;
+		rect.p1.y = 1;
+	} else {
+		rect.p0.x = params.rect.p1.x - 80;
+		rect.p0.y = 4;
+		rect.p1.x = params.rect.p1.x - 4;
+		rect.p1.y = 32 - 4;
+	}
+
+	taskbar_clock_set_rect(taskbar->clock, &rect);
+
+	rc = ui_fixed_add(taskbar->fixed, taskbar_clock_ctl(taskbar->clock));
+	if (rc != EOK) {
+		printf("Error adding control to layout.\n");
+		taskbar_clock_destroy(taskbar->clock);
+		goto error;
+	}
+
+	ui_window_add(taskbar->window, ui_fixed_ctl(taskbar->fixed));
+
+	rc = ui_window_paint(taskbar->window);
+	if (rc != EOK) {
+		printf("Error painting window.\n");
+		goto error;
+	}
+
+	*rtaskbar = taskbar;
+	return EOK;
+error:
+	if (taskbar->clock != NULL)
+		taskbar_clock_destroy(taskbar->clock);
+	if (taskbar->wndlist != NULL)
+		wndlist_destroy(taskbar->wndlist);
+	if (taskbar->window != NULL)
+		ui_window_destroy(taskbar->window);
+	if (taskbar->ui != NULL)
+		ui_destroy(taskbar->ui);
+	return rc;
+
+}
+
+/** Destroy task bar. */
+void taskbar_destroy(taskbar_t *taskbar)
+{
+	ui_fixed_remove(taskbar->fixed, taskbar_clock_ctl(taskbar->clock));
+	taskbar_clock_destroy(taskbar->clock);
+	ui_window_destroy(taskbar->window);
+	ui_destroy(taskbar->ui);
+}
+
+/** @}
+ */
